/*!
    \file   SocketsManager.cpp
    \brief  SocketQ ǗNX

    Copyright (c) 2005 Yamami
    All rights reserved.
    License=MIT/X License

    \author  Yamami
    \version $Revision: 1.1 $
    \date   create:2005/07/15 update:$Date: 2005/07/22 08:39:32 $
*/

/*! \class SocketsManager
 *  \brief SocketQ ǗNX
 */


#include <monesoc/SocketsManager.h>

/*!
    \brief initialize
         SocketsManager RXgN^
    \author Yamami
    \date   create:2004/10/11 update:$Date: 2005/07/22 08:39:32 $
*/
SocketsManager::SocketsManager()
{
    //RlNVAуXnbVCX^X
    conSocHash = new HashMap<Socket*>(MAX_SOC_SIZE);
    lisSocHash = new HashMap<Socket*>(MAX_SOC_SIZE);    
}


/*!
    \brief findSocket
         \Pbg
    \param  dword ip [in] IPAhX
    \param  word  myport [in] ȃ|[gԍ
    \param  word  youport[in] |[gԍ
    \return Socket*  Socketւ̃|C^BȂꍇNULL|C^
        
    \author Yamami
    \date   create:2005/07/20 update:
*/
Socket* SocketsManager::findSocket(dword ip ,word  myport ,word youport)
{
    char SocKey[30];    //SocketL[
    Socket *retSoc;     //Socket^[
    
    //RlNV\PbgT
    //MAP̃L[(String)
    sprintf(SocKey , "%08x%08x%08x",myport,ip,youport);
    retSoc = conSocHash->get(SocKey);
    
    if(retSoc!=NULL){
        return retSoc;
    }
    
    //X\PbgT
    //MAP̃L[(String)
    sprintf(SocKey , "%08x",myport);
    retSoc = lisSocHash->get(SocKey);
    
    if(retSoc!=NULL){
        return retSoc;
    }    

    return NULL;
}


/*!
    \brief registLisSocket
         X\Pbgo^
    \param  dword tid [in] Xbhid
    \param  word  myport [in] ȃ|[gԍ
    \return 
        
    \author Yamami
    \date   create:2005/07/20 update:
*/
void SocketsManager::registLisSocket(dword tid ,word  myport )
{
    Socket *soc;
    
    soc = new Socket();
    soc->tid = tid;
    soc->myport = myport;
    soc->status = LISTEN;

    char SocKey[30];    //SocketL[
    
    sprintf(SocKey , "%08x",myport);
    lisSocHash->put(SocKey , soc);
}


/*!
    \brief registConSocket
         RlNV\Pbgo^
    \param  dword tid [in] Xbhid
    \param  word  myport [in] ȃ|[gԍ
    \param  dword ip [in] IPAhX
    \param  word  youport[in] |[gԍ    
    \return 
        
    \author Yamami
    \date   create:2005/07/20 update:
*/
void SocketsManager::registConSocket(dword tid ,word myport, dword ip , word youport)
{
    Socket *soc;
    
    soc = new Socket();
    soc->tid = tid;
    soc->myport = myport;
    soc->ip = ip;
    soc->youport = youport; 
    soc->status = ESTABLISHED;

    char SocKey[30];    //SocketL[
    
    sprintf(SocKey , "%08x%08x%08x",myport,ip,youport);
    conSocHash->put(SocKey , soc);
}
