/*!
    \file   MoUdp.cpp
    \brief  UDPvgRNX

    Copyright (c) 2005 Yamami
    All rights reserved.
    License=MIT/X License

    \author  Yamami
    \version $Revision: 1.5 $
    \date   create:2005/05/11 update:$Date: 2005/07/22 08:33:54 $
*/

/*! \class MoUdp
 *  \brief UDPvgRNX
 */



#include "MoUdp.h"
#include "MonesConfig.h"
#include "MonesGlobal.h"
#include <monesoc/SocketsManager.h>
#include <monesoc/Socket.h>

/*!
    \brief initialize
         MoUdp RXgN^
    \author Yamami
    \date   create:2004/09/20 update:
*/
MoUdp::MoUdp()
{

}

/*!
    \brief initialize
         MoUdp initIp
    \author Yamami
    \param  AbstractMonic *pminsNic [in] NICNXւ̃|C^
    \date   create:2004/09/20 update:
*/
void MoUdp::initUdp(AbstractMonic *pminsNic ) 
{
    //NICNXێ
    insAbstractNic = pminsNic;
    return;
}


/*!
    \brief initialize
         MoUdp fXNgN^
    \author Yamami
    \date   create:2004/08/20 update:
*/
MoUdp::~MoUdp() 
{

}


/*!
    \brief receiveUdp
         UDPvgRM 
    \param  IP_HEADER *ipHead [in] IPwb_ւ̃|C^
    \return int  
        
    \author Yamami
    \date   create:2004/09/20 update:2004/09/20
*/
int MoUdp::receiveUdp(IP_HEADER *ipHead)
{
    DUMMY_HEADER dmyhead;
    
    int udp_size;
    UDP_HEADER *udp;

    udp=(UDP_HEADER*)ipHead->data;

    //udp_size=MoPacUtl::swapShort(ipHead->len)-sizeof(IP_HEADER);
    udp_size=MoPacUtl::swapShort(udp->len);

    // `FbNT̊mF
    // UDP̃`FbNT́A^wb_čsB
    dmyhead.srcip=ipHead->srcip;
    dmyhead.dstip=ipHead->dstip;
    dmyhead.tmp=0;
    dmyhead.prot=ipHead->prot;
    dmyhead.len=udp->len;
    if(MoPacUtl::calcCheckSumDummyHead((dword*)&dmyhead,(dword*)udp,sizeof(DUMMY_HEADER),udp_size)){
        logprintf("udp_size = %d\n",udp_size);
        logprintf("udp->chksum = %x\n",MoPacUtl::swapShort(udp->chksum));
        logprintf("udp CheckSum BAD!!\n");
        return 0;
    }

    saveRecv(ipHead,udp_size+sizeof(IP_HEADER));

    return 0;
}


/*!
    \brief transUdp
         UDPM 
    \param  word dstip [in] MIPAhX
    \param  byte type [in] UDP^Cv
    \param  UDP_HEADER *udpHead [in] UDPwb_ւ̃|C^
    \param  int size [in] pPbgTCY
    \return 
        
    \author Yamami
    \date   create:2004/09/20 update:2004/09/20
*/
void MoUdp::transUdp(dword dstip, byte type, byte code, UDP_HEADER *udpHead, int size)
{
    
    TRANS_BUF_INFO tbi;

    //UDPwb_[̐ݒ
    //udpHead->type=type;
    //udpHead->code=code;
    //udpHead->chksum=0;
    //udpHead->chksum=MoPacUtl::calcCheckSum((dword*)udpHead,size);

    //Mobt@e[u̐ݒ
    //tbi.data[2]=NULL;
    //tbi.size[2]=0;
    //tbi.data[1]=(char*)udpHead;
    //tbi.size[1]=size;
    //tbi.ipType=IPPROTO_UDP;

    g_MoIp->transIp(&tbi,dstip,0,0);
}


/*!
    \brief saveRecv
         UDPM 
    \param  IP_HEADER *ipHead [in] IPwb_
    \param  int size [in] pPbgTCY
    \return 
    \author Yamami
    \date   create:2004/09/20 update:2004/09/20
*/
void MoUdp::saveRecv(IP_HEADER *ipHead, int size)
{
    MessageInfo info;

    int udp_size;
    UDP_HEADER *udp;

    udp=(UDP_HEADER*)ipHead->data;
    udp_size=MoPacUtl::swapShort(ipHead->len)-sizeof(IP_HEADER);

    //œUDPpPbgfobO
    if (MoPacUtl::swapShort(udp->dstport) == 2600){
        char buf[1530];
        memset(buf,0,sizeof(buf));
        logprintf("srcip = %x\n",MoPacUtl::swapLong(ipHead->srcip));
        logprintf("dstport = %x\n",MoPacUtl::swapShort(udp->dstport));
        logprintf("size = %x\n",udp_size);
        memcpy(buf, udp->data , udp_size);
        for(int i = 0; i < udp_size ; i++){
            logprintf("%c",buf[i]);
        }
        logprintf("\n");
    }

    //X邢́ARlNgĂ\Pbg
    if(Socket* soc = g_SocketsManager->findSocket(MoPacUtl::swapLong(ipHead->srcip) 
        , MoPacUtl::swapShort(udp->dstport) 
        , MoPacUtl::swapShort(udp->srcport))){
        
        int reti;
        
        
logprintf("if(Socket* soc = IN!!! \n");
        //\Pbg̎Mobt@֒ǉ
        reti = soc->addBuffer(udp->data , udp_size , 0);
        
logprintf("reti = soc->addBuffer After!!! \n");
        
        //o^ĂvZXɒʒmB
        // create message
        //TODO ̃bZ[W͕sK(ICMP) vgRƂɃbZ[WςH
        Message::create(&info, MSG_MONES_ICMP_NOTICE, 0, 0, 0, NULL);
        
        //MoPacUtlŃbZ[WSocketZbg
        reti = MoPacUtl::createPacMsg(&info , soc);
        
        // send
        if (Message::send(soc->tid, &info)) {
            //printf("MoUdp::saveRecv error\n");
        }        
        
    }
    
}
