/*!
    \file  MonesDefine.h
    \brief eO[o萔錾

    Copyright (c) 2004 Yamami
    All rights reserved.
    License=MIT/X License

    \author  Yamami 
    \version $Revision: 1.11 $
    \date   create:2004/08/28 update:$Date: 2005/07/17 05:09:23 $
*/

#include <monapi/cmemoryinfo.h>

#ifndef _MONA_MONESDEFINE_
#define _MONA_MONESDEFINE_

/* Ethernet MACwwb_\ */
#define SIZEOF_ETHERADDR    6

//DIXdlt[̃t[^Cv
#define ETHER_PROTO_IP      0x0800      // IPvgRt[
#define ETHER_PROTO_ARP     0x0806      // ARPvgRt[

#define etherhdr_dest_addr  0
#define etherhdr_src_addr   (etherhdr_dest_addr+SIZEOF_ETHERADDR)
#define etherhdr_type       (etherhdr_src_addr+SIZEOF_ETHERADDR)
#define SIZEOF_ETHERHDR     (etherhdr_type+2)


//IPwb_vgRNo
enum{
    IPPROTO_IP,         /* Internet protocol. */
    IPPROTO_IPV6,       /* Internet Protocol Version 6. */
    IPPROTO_ICMP=1,     /* Control message protocol. */
    IPPROTO_IGMP=2,
    IPPROTO_RAW,        /* Raw IP Packets Protocol. */
    IPPROTO_TCP=6,      /* Transmission control protocol. */
    IPPROTO_UDP=17,     /* User datagram protocol. */

    INADDR_ANY=      0,             /* IPv4 local host address. */
    INADDR_BROADCAST=0xffffffff,    /* IPv4 broadcast address. */
};


/* IPwb_\ */
#define     SIZEOF_IPADDR       4

#define     iphdr_version   0               /* 1 */
#define     iphdr_service   (iphdr_version+1)       /* 1 */
#define     iphdr_len   (iphdr_service+1)       /* 2 */
#define     iphdr_ident (iphdr_len+2)           /* 2 */
#define     iphdr_frags (iphdr_ident+2)         /* 2 */
#define     iphdr_ttl   (iphdr_frags+2)         /* 1 */
#define     iphdr_protocol  (iphdr_ttl+1)           /* 1 */
#define     iphdr_chksum    (iphdr_protocol+1)      /* 2 */
#define     iphdr_src_addr  (iphdr_chksum+2)        /* 4 */
#define     iphdr_dest_addr (iphdr_src_addr+4)      /* 4 */
#define     SIZEOF_IPHDR    (iphdr_dest_addr+4)



/*! 
 *  \struct IP_HEADER
 *  \brief IPwb_\
 */
typedef struct{
    byte  verhead;  /* o[WAwb_B */
    byte  tos;      /* TOS. */
    word len;       /* g[^B */
    word id;        /* ʔԍB */
    word frag;      /* tOAtOgItZbgB */
    byte  ttl;      /* Time to Live. */
    byte  prot;     /* vgRԍB */
    word chksum;    /* wb_`FbNTB */
    dword srcip;        /* 茳IPB */
    dword dstip;        /* IPB */
    char     data[0];
}IP_HEADER;


enum{
    IP_HEAD_VERSION=4<<4,

    IP_HEAD_FRAG_ON= 0x2000,    /* tOgf[^tOB */
    IP_HEAD_FRAG_NOT=0x4000,    /* tOgstOB */
};


/*! 
 *  \struct DUMMY_HEADER
 *  \brief ^wb_BTCP/UDP̃`FbNTvZɗpB
 */
typedef struct{
    dword srcip;
    dword dstip;
    byte  tmp;
    byte  prot;
    word len;
}DUMMY_HEADER;



//ICMP ^Cv
//0 GR[iecho replyj 
//3 ĐsBidestination unreachablej 
//4 \[XENG`isource quenchAM}j 
//5 _CNgviredirectAoHύXvj 
//8 GR[viecho requestj 
//11 Ԓ߁itime exceededj 
//12 p[^ُiparameter problemj 
//13 ^CX^vvitimestamp requestj 
//14 ^CX^vitimestamp replyj 
//15 viinformation requestj 
//16 񉞓iinformation replyj 
//17 AhXE}XNviaddress mask requestj 
//18 AhXE}XNiaddress mask replyj 
enum{
    ICMP_TYPE_ECHOREP=0,
    ICMP_TYPE_ECHOREQ=8,
};


/*! 
 *  \struct ICMP_HEADER
 *  \brief ICMPwb_\
 */
typedef struct{
    unsigned char  type;        /* ICMP^CvB */
    unsigned char  code;        /* ICMPR[hB */
    unsigned short chksum;      /* `FbNTB */
    char           data[32];     /* f[^B */
}ICMP_HEADER;



/*! 
 *  \struct UDP_HEADER
 *  \brief UDPwb_\
 */
 typedef struct{
    word srcport;
    word dstport;
    short len;
    word chksum;
    char   data[0];
}UDP_HEADER;


/*! 
 *  \struct TCP_HEADER
 *  \brief TCPwb_\
 */
typedef struct{
    word srcport;
    word dstport;
    dword seqnum;
    dword acknum;
    byte reserved :4;
    byte  headlen :4 ;
    byte  flag;
    word wndsize;
    word chksum;
    word urgpoint;
    char    option[0];
}TCP_HEADER;


/*! 
 *  \struct TRANS_BUF_INFO
 *  \brief IPMobt@\
 */
struct TRANS_BUF_INFO{
    char  *data[3];     /* Mt[AhXB */
    int    size[3];     /* f[^t[TCYB */
    word type;        /* t[^CvB */
    dword  ipType;      /* IPvgR^CvB */
};


/*! 
 *  \struct MAC_REPLY_WAIT
 *  \brief ARPv҂Ǘ \
 */
struct MAC_REPLY_WAIT{
    dword ip;         //vIPAhX
    int repFlg;       //Reply flag 0:҂ 1:
    int wait;         //EFCg 
    char mac[6];      //MACAhXi[
    dword  ipType;    /* IPvgR^CvB */
    //TRANS_BUF_INFO* ipPacketBuf; //IPpPbgobt@
    monapi_cmemoryinfo* ipPacketBuf01;  //IPpPbgobt@01
    monapi_cmemoryinfo* ipPacketBuf02;  //IPpPbgobt@02
};

/*! 
 *  \struct MONES_IP_REGIST
 *  \brief Moneso^
 */
struct MONES_IP_REGIST{
    dword ip;         //ʐMIP
    word port;       //ʐMPORT
    dword tid;        //XbhID
};


#endif
