/*!
  \file  mones.cpp
  \brief Code:MonesC

  Copyright (c) 2004 Yamami
  All rights reserved.
  License=MIT/X License

  \author  Yamami
  \version $Revision: 1.16 $
  \date   create:2004/08/08 update:$Date: 2005/07/22 16:26:28 $
*/


//ŁAMones̃O[oIuWFNgCX^X
#define MONES_GLOBAL_VALUE_DEFINED
#include "MonesGlobal.h"

#include <monapi.h>
#include "AbstractMonic.h"
#include "MoEther.h"
#include "MoIcmp.h"
#include "MonesConfig.h"
#include "MonesLoader.h"



using namespace MonAPI;


/*!
    \brief MonaMain
        Code:MonesC

    \param List<char*>* pekoe

    \author  Yamami
    \date    create:2004/08/08 update:2004/10/31
*/
int MonaMain(List<char*>* pekoe)
{
    
    int ret;
    
    //MonesRList = new HList<MONES_IP_REGIST*>();
    //MONES_IP_REGIST *regist;
    
    //̃vZX쒆́AIOx3܂ŋ
    syscall_get_io();
    
    // NIC̃CX^X
    // MonesLoaderNXoRŃCX^XB
    AbstractMonic* insAbstractNic;
    
    MonesLoader* insNicLoader = new MonesLoader();
    insNicLoader->setup();
    insAbstractNic = insNicLoader->getNicInstance();
    //NIC̃[hɎsꍇ́AMonesI
    if(insAbstractNic == 0){
        printf("NIC Error Mones Quit \n");
        exit(1);
    }
    
    //EtherNX̃CX^X
    g_MoEther = new MoEther();
    g_MoEther->etherInit(insAbstractNic);

    //ARPNX̃CX^X
    g_MoArp = new MoArp();
    g_MoArp->initArp(insAbstractNic);

    //IPNX̃CX^X
    g_MoIp = new MoIp();
    g_MoIp->initIp(insAbstractNic);

    //UDPNX̃CX^X
    g_MoUdp = new MoUdp();
    g_MoUdp->initUdp(insAbstractNic);

    //TCPNX̃CX^X
    g_MoTcp = new MoTcp();
    g_MoTcp->initTcp(insAbstractNic);

    //SocketsManagerNX̃CX^X
    g_SocketsManager = new SocketsManager();
    
    // Server start ok
    MessageInfo info;
    dword targetID = Message::lookupMainThread("MONITOR.BIN");
    if (targetID == 0xFFFFFFFF)
    {
        printf("Mones:INIT not found\n");
        exit(1);
    }

    // create message
    Message::create(&info, MSG_SERVER_START_OK, 0, 0, 0, NULL);

    // send
    if (Message::send(targetID, &info)) {
        printf("Mones:INIT error\n");
    }

    //lbg[NIRQ}XNEnable
    insAbstractNic->enableNetWork();

    //IRQV[oƂēo^ (IRQ́ANIChCoNX蓾)
    syscall_set_irq_receiver(insAbstractNic->getNicIRQ());

    //Mones̃vCIeB
    syscall_change_base_priority(1);

    /* Message loop */
    //ŃbZ[W[v
    for (;;)
    {
        /* receive */
        if (!Message::receive(&info))
        {
            
            switch(info.header)
            {
            
            //NICn[hEFÅ荞ݗv
            case MSG_INTERRUPTED:
                
                //logprintf("MSG_INTERRUPTED\n");
                                
                //pPbgM҂Xg֓o^
                insAbstractNic->frame_input_public();
                
                break;

            //Mones̃pPbgv
            //TODO {́AvgRw̎d
            // ̃XR[v𖾎͏dv crosses initialization
            case MSG_MONES_FRAME_REQ: {
                
                //logprintf("MSG_MONES_FRAME_REQ\n");
                
                //҂͂邩H
                if(insAbstractNic->waitFrameBufList->isEmpty()){
                    break;
                }
                
                //L҂pPbg擾                
                WAIT_FRAME_BUF* bgetWork = insAbstractNic->waitFrameBufList->removeAt(0);
                
                monapi_cmemoryinfo* cmPac;

                cmPac = monapi_cmemoryinfo_new();
                cmPac->Handle = bgetWork->cmHandle;
                //cmPac->Owner  = tid;
                cmPac->Size   = bgetWork->cmSize;
                monapi_cmemoryinfo_map(cmPac);

                dword    i;
                //EtherNXɓo^
                i = g_MoEther->setEtherFrame(cmPac->Data ,cmPac->Size);
                //C[Tlbgt[M
                i = g_MoEther->receiveEther();                
                
                //L
                monapi_cmemoryinfo_dispose(cmPac);
                monapi_cmemoryinfo_delete(cmPac);
                
                //Xg
                delete bgetWork;

                break;
            }

            //AvMones֓o^
            case MSG_MONES_REGIST:
                
                //printf("MSG_MONES_REGIST\n");
                
                //XXgɓo^
                g_SocketsManager->registLisSocket(info.from , (word)info.arg2);
                
                break;

            //AṽpPbgMv
            case MSG_MONES_IP_SEND:
                
                //printf("MSG_MONES_IP_SEND\n");
                
                //pPbgM
                //Ƃ肠́AMessageInfo str 128oCg܂ŃT|[g
                //ȏ̃TCÝALp
                if(info.arg1 == 0){

                    int icmp_size;
                    icmp_size=info.length;

                    dword ip;
                    TRANS_BUF_INFO *tbi;
                    tbi = new TRANS_BUF_INFO();
                    
                    ICMP_HEADER *volatile icmpHead;
                    //icmpHead = new ICMP_HEADER();
                    icmpHead=(ICMP_HEADER*)info.str;
                    
                    
                    //M 2̒l
                    ip = info.arg2;
                    
                    //ICMP `FbNTvZ
                    icmpHead->chksum=0;
                    icmpHead->chksum=MoPacUtl::calcCheckSum((dword*)icmpHead,icmp_size);

                    //Mobt@e[u̐ݒ
                    tbi->data[2]=NULL;
                    tbi->size[2]=0;
                    tbi->data[1]=(char*)icmpHead;
                    tbi->size[1]=icmp_size;
                    tbi->ipType=IPPROTO_ICMP;
        
                    ret = g_MoIp->transIp(tbi , MoPacUtl::swapLong(ip) ,0, 0);
                    
                    //printf("MoPacUtl::swapLong(ip)=%x\n",MoPacUtl::swapLong(ip));
                }
                
                break;

            //ARP҂Wake Up
            case MSG_MONES_WAKEUP_ARP_WAIT:
                
                //printf("MSG_MONES_WAKEUP_ARP_WAIT\n");
                
                MAC_REPLY_WAIT* nowWait;
                
                //ARPv҂Xǧ
                for (int i = 0; i < g_MoArp->macWaitList->size() ; i++) {
                    nowWait = g_MoArp->macWaitList->get(i);
                    
                    if(nowWait->repFlg == 1){
                        //ARPς݂ȂA҂pPbg𑗐MB
                        TRANS_BUF_INFO *tbi;
                        tbi = new TRANS_BUF_INFO();
                        
                        //Mobt@e[u̐ݒ
                        tbi->data[2]=NULL;
                        tbi->size[2]=0;
                        tbi->data[1]=(char*)MonAPI::MemoryMap::map(nowWait->ipPacketBuf01->Handle);
                        tbi->size[1]=nowWait->ipPacketBuf01->Size;
                        tbi->ipType=nowWait->ipType;
                        
                        ret = g_MoIp->transIp(tbi , nowWait->ip ,0, 0);
                        
                        
                        //ҔĂIPpPbgobt@̉
                        //free(nowWait->ipPacketBuf);
                        monapi_cmemoryinfo_dispose(nowWait->ipPacketBuf01);
                        monapi_cmemoryinfo_delete(nowWait->ipPacketBuf01);
                        
                        
                        //҂Xg폜
                        g_MoArp->macWaitList->removeAt(i);
                        //JE^fNgB
                        i--;
                    }
                }
                
                
                break;

            default:
                /* igonore this message */
                break;
            }

        }
    }
    return 0;
}

